using System;
using System.Collections.Generic;

namespace PAT.Common.Classes.Expressions.ExpressionClass
{
    public sealed class Sequence : Expression
    {
        public Expression FirstPart, SecondPart;
        public Sequence(Expression f, Expression s)
        {
            FirstPart = f;
            SecondPart = s;
            HasVar = f.HasVar || s.HasVar;
            ExpressionType = ExpressionType.Sequence;
            expressionID = FirstPart.ExpressionID + ";" + SecondPart.ExpressionID;

        }

        public override String ToString()
        {
            return FirstPart + " " + SecondPart;
        }

        //public override String GetID()
        //{
        //    return FirstPart.GetID() + ";" + SecondPart.GetID();
        //}

        public override List<string> GetVars()
        {
            List<string> vars = FirstPart.GetVars();
            Ultility.Ultility.AddList(vars, this.SecondPart.GetVars());
            return vars;
        }

        public override Expression ClearConstant(Dictionary<string, Expression> constMapping)
        {
            return new Sequence(FirstPart.ClearConstant(constMapping), SecondPart.ClearConstant(constMapping));
        }

        public override bool HasExternalLibraryCall()
        {
            return FirstPart.HasExternalLibraryCall() || SecondPart.HasExternalLibraryCall();
        }
    }
}