using System;
using System.Collections.Generic;

namespace PAT.Common.Classes.Expressions.ExpressionClass
{
    public sealed class While : Expression
    {      
        public Expression Test, Body;
        public While(Expression t, Expression b)
        {
            Test = t;
            Body = b;
            this.HasVar = t.HasVar || b.HasVar;
            ExpressionType = ExpressionType.While;

            expressionID = "W@" + Test.ExpressionID + "{" + Body.ExpressionID + "}";
        }


        public override String ToString()
        {
            return "while (" + Test.ToString() + ") {" + Body.ToString() + "}";
        }

        //public override String GetID()
        //{
        //    return "W@" + Test.GetID() + "{" + Body.GetID() + "}";
        //}

        public override List<string> GetVars()
        {
            List<string> vars = Test.GetVars();
            Ultility.Ultility.AddList(vars, Body.GetVars());
            return vars;
        }

        public override Expression ClearConstant(Dictionary<string, Expression> constMapping)
        {
            return new While(Test.ClearConstant(constMapping), Body.ClearConstant(constMapping));
        }

        public override bool HasExternalLibraryCall()
        {
            return Test.HasExternalLibraryCall() || Body.HasExternalLibraryCall();
        }
    }
}