using System;
using System.Threading;
using System.Windows.Forms;

namespace PAT.GUI
{
    
    internal static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        private static void Main(string[] files)
        {
            Application.SetCompatibleTextRenderingDefault(false);
            Application.EnableVisualStyles();
            Application.DoEvents(); 

            
            //Application.SetUnhandledExceptionMode(UnhandledExceptionMode.CatchException);
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Application_ThreadException);

            try
            {
                GUIUltility.ReadSettingValue();
            }
            catch (Exception)
            {
            }

            //if (GUIUltility.CHECK_UPDATE_AT_START && Common.Ultility.Ultility.IsWindowsOS)
            //{

            //    //if there is a update, then we need to exit simplely.
            //    if (GUIUltility.UpdatePAT(files, false))
            //    {
            //        return;
            //    }
            //}

            FormMain mainForm = new FormMain();
           

            try
            {
                if (files.Length > 0)
                {
                    mainForm.OpenFile(files[0], false);
                }
                else
                {
                    mainForm.OpenFileLastFile();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Invalid File on arguments:" + ex.Message + ex.StackTrace);
            }

            mainForm.StartCheckUpdate();

            Application.Run(mainForm);
            
        }


        static void Application_ThreadException(object sender, System.Threading.ThreadExceptionEventArgs e)
        {
            MessageBox.Show("Unhandled Exception: " + e.Exception.Message + "\r\n" + e.Exception.StackTrace);
        }
    }
}