using PAT.Common.Classes.LTS;
using PAT.Common.Classes.ModuleInterface;
using PAT.Common.Classes.SemanticModels.LTS.Assertion;
using PAT.PAR.LTS;

namespace PAT.PAR.Assertions
{
    public class PARAssertionReachability : AssertionReachability
    {
        private DefinitionRef Process;

        public PARAssertionReachability(DefinitionRef processDef, string reachableState) : base(reachableState)
        {
            Process = processDef;
        }

        public override void Initialize(SpecificationBase spec)
        {
            base.Initialize(spec);

            Specification Spec = spec as Specification;
            ReachableStateCondition = Spec.DeclarationDatabase[ReachableStateLabel];
            PARAssertion.Initialize(this, Process, spec);

        }


        public override string StartingProcess
        {
            get
            {
                return Process.ToString();
            }
        }
    }
}