﻿using System.Windows.Forms;
using Microsoft.Win32;
using PAT.Common.GUI;
using PAT.PAR.Ultility;

namespace PAT.PAR.GUI
{
    public partial class OptionPanel : OptionPanelInterface
    {
        public OptionPanel()
        {
            InitializeComponent();
        }

        public override void LoadData()
        {
            this.NUP_ClockCeiling.Value = PARUltility.TIME_REFINEMENT_CLOCK_CEILING;
            this.NUP_ClockFloor.Value = PARUltility.TIME_REFINEMENT_CLOCK_FLOOR;
            CheckBox_TauUrgent.Checked = PARUltility.TAU_URGENT;
            CheckBox_LinkRTS.Checked = PARUltility.LINK_PAR;
        }

        public override void WriteData()
        {
            PARUltility.TAU_URGENT = CheckBox_TauUrgent.Checked;
            PARUltility.TIME_REFINEMENT_CLOCK_CEILING = (int)this.NUP_ClockCeiling.Value;
            PARUltility.TIME_REFINEMENT_CLOCK_FLOOR = (int)this.NUP_ClockFloor.Value;

            PARUltility.LINK_PAR = CheckBox_LinkRTS.Checked;

            if (CheckBox_LinkRTS.Checked)
            {
                if (Registry.CurrentUser.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.rts") != null)
                {
                    Registry.CurrentUser.DeleteSubKeyTree(@"Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.rts");
                }
                Registry.ClassesRoot.CreateSubKey(".rts").SetValue("", "RTS", Microsoft.Win32.RegistryValueKind.String);
                Registry.ClassesRoot.CreateSubKey(@".rts\shell\open\command").SetValue("", Application.ExecutablePath + " \"%1\"", Microsoft.Win32.RegistryValueKind.String);
            }
            else
            {
                if (Registry.ClassesRoot.OpenSubKey(".rts") != null)
                {
                    Registry.ClassesRoot.DeleteSubKeyTree(".rts");
                }
            }
        }

        public override void ResetDefaultValue()
        {
            this.CheckBox_TauUrgent.Checked = false;
            this.CheckBox_LinkRTS.Checked = true;

            this.NUP_ClockCeiling.Value = 32767;
            this.NUP_ClockFloor.Value = -32768;

        }
    }


}
