﻿//using System;
using System.Linq;
//using System.Runtime.InteropServices;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using PAT.Common.Classes.Ultility;
using System.Runtime.InteropServices;
using System.IO;
using System.Windows.Forms;

namespace PAT.PAR.LTS
{
     



    // The operators
    public enum TimerOperationType : byte
    {
        Equals,
        LessThanOrEqualTo,
        GreaterThanOrEqualTo,
        LessThan,
        GreaterThan
    }


    public class Constraint
    {

        /* CONSTANTES */
        private const int FIRST_CLOCK = 1;

        private const string POLYOP_INPUT = "test.polyop";
        private const string POLYOP_OUTPUT = "test.polyop.res";


        /* MEMBERS */
        // The list of clocks
        private List<byte> ClockList;
        // The latest clock
        private byte LatestClock;
        // WHAT ?!
        private bool LatestClockIsNew;
        // WHAT ?!
#if Statistics
        public static byte ClockNumber;
#endif

        // FAKE IMPLEMENTATION (Fake constraint under the form of a string)
        private string theConstraint;


        private void writeToFile(string fileName, string text)
        {
            // create a writer and open the file
            TextWriter tw = new StreamWriter(fileName);

            // write all lines (?) to the file
            tw.WriteLine(text);

            // close the stream
            tw.Close();
        }


        // Read from a text file
        private string fileToString(string fileName)
        {
            System.IO.StreamReader myFile = new System.IO.StreamReader(fileName);
            string myString = myFile.ReadToEnd();
            // Check that no error occured
            if (myString == "" || myString == "error")
            {
                throw new Exception("Exception when reading the content of file "
                    + fileName
                    + " after executing PolyOp. Found: '"
                    + myString + "'.");
            }
            return myString;
        }


        // Convert a bool result from PolyOp to a bool
        private bool polyopToBool(string PolyOpResult)
        {
            // Check the result
            if(PolyOpResult == "yes") return true;
            if(PolyOpResult == "no") return false;
            // Throw an exception is result non conform
            throw new Exception("Internal error linked to PolyOp: the file return by PolyOp contains '"
                + PolyOpResult + "'; expected: 'yes' or 'no'.");
        }


        private void polyOp(){
            // Use ProcessStartInfo class
            ProcessStartInfo startInfo = new ProcessStartInfo();
            startInfo.CreateNoWindow = true;
            startInfo.UseShellExecute = true;
            // p.StartInfo.FileName = @"C:\some.exe";
            startInfo.FileName = "PolyOp"; //  toto.polyop
            //startInfo.WindowStyle = ProcessWindowStyle.Hidden;
            //startInfo.Arguments = "toto.polyop";

            // p.StartInfo.WorkingDirectory = @"C:\whatever";
            // p.Start(startInfo);

            Process exeProcess = Process.Start(startInfo);
            exeProcess.WaitForExit();

            //try
            //{
            // Start the process with the info we specified.
            // Call WaitForExit and then the using statement will close.
            //                using (Process exeProcess = Process.Start(startInfo))
            //              {
            //                exeProcess.WaitForExit();
            //          }
            //}
            //catch (Exception ex)
            //{
            //    MessageBox.Show(System.Resources.Exception_happened__ + ex.Message + "\r\n" + ex.StackTrace,
            //                    Ultility.APPLICATION_NAME, MessageBoxButtons.OK, MessageBoxIcon.Error);
            //}

        }


        // Write "constraint" to the PolyOp file, call PolyOp, get the result and return it
        private string processConstraint(string constraint)
        {
            // Write the constraint to the PolyOp file
            writeToFile(POLYOP_INPUT, constraint);
            // DEBUG
            Console.WriteLine("About to ask PolyOp to do: '" + constraint + "'");
            // Call PolyOp
            polyOp();
            // Get the result 
            string result = fileToString(POLYOP_OUTPUT);
            // DEBUG
            Console.WriteLine("PolyOp says: '" + result+ "'");
            // Return it
            return result;
        }


        private Constraint()
        {
            // Initialize the list of clocks
            ClockList = new List<byte>();

            // Initialize the constraint
            // FAKE IMPLEMENTATION
            theConstraint = "undefined";
        }


        
        public static Constraint trueConstraint()
        {
            Constraint c = new Constraint();
            // FAKE IMPLEMENTATION
            c.theConstraint = "true";
            return c;
        }


        
        //public static Constraint falseConstraint()
        //{
        //    Constraint c = new Constraint();
        //    // FAKE IMPLEMENTATION
        //    c.theConstraint = "false";
        //    return c;
        //}




        public byte getLatestClock()
        {
            return LatestClock;
        }



        public int GetNbClocks()
        {
            // ETIENNE SAYS: DEBUG
            //theConstraint += "{getnbclocks: " + ClocksToString() + "}";

            return ClockList.Count();
        }



        // Check if a constraint satisfies an inequality "clock ~ constant"
        public bool ImpliesInequality(byte clockID, TimerOperationType op, int constant)
        {
            // ETIENNE SAYS: FAKE IMPLEMENTATION
            string inequality = ClockToString(clockID) + opToString(op) + constant.ToString();
            string operation = "included(" + this.theConstraint + ", " + inequality + ")";
            string result = processConstraint(operation);
            return polyopToBool(result);
        }




        // Check if a constraint satisfies a parametric inequality "clock ~ parameter"
        public bool ImpliesParInequality(byte clockID, TimerOperationType op, string parameter)
        {
            // ETIENNE SAYS: FAKE IMPLEMENTATION
            string inequality = ClockToString(clockID) + opToString(op) + parameter;
            string operation = "included(" + this.theConstraint + ", " + inequality + ")";
            string result = processConstraint(operation);
            return polyopToBool(result);
        }



        // Timed delay on the constraint
        public void Delay()
        {
            if (theConstraint == "true") return; // just to keep display clean...

            // ETIENNE SAYS: FAKE IMPLEMENTATION
            string operation = "elapsing (" + ClocksToString() + ") in (" + this.theConstraint + ")";
            string result = processConstraint(operation);
            theConstraint = result;
        }



        // Remove the clocks not in "clocks"; keep the others and the parameters
        public Constraint KeepClocks(List<byte> ClocksToKeep)
        {
            // Compute the list of clocks to remove
            List<byte> ClocksToRemove = ListDiff(ClockList, ClocksToKeep);

            // ETIENNE SAYS: FAKE IMPLEMENTATION
            if (theConstraint == "true") return this.Clone() ; // just to keep display clean...

            string operation = "hide(" + SomeClockstoString(ClocksToRemove) + ") in (" + this.theConstraint + ")";
            string result = processConstraint(operation);

            Constraint newConstraint = trueConstraint();
            newConstraint.theConstraint = result;

            // Update the list of clocks
            // ETIENNE SAYS: SHOULD WE DO A CLONE() HERE?
            newConstraint.ClockList = new List<byte>(ClocksToKeep);

            return newConstraint;
        }




        public Constraint HideAllClocks()
        {
            // ETIENNE SAYS: FAKE IMPLEMENTATION
            if (theConstraint == "true") return this.Clone(); // just to keep display clean...

            string operation = "hide(" + ClocksToString() + ") in (" + this.theConstraint + ")";
            string result = processConstraint(operation);

            Constraint newConstraint = trueConstraint();
            newConstraint.theConstraint = result;

            // Empty the list of clocks
            newConstraint.ClockList = new List<byte>();
            
            return newConstraint;
        }


        // Test if all elements of l1 belong to l2
        private static bool ListIncluded(List<byte> l1, List<byte> l2){
            foreach (byte elem in l1)
            {
                if (!l2.Contains(elem)){
                    return false;
                }
            }
            return true;
        }

        // Computes the difference between l1 \ l2, i.e., the elements of l1 minus the elements of l2
        private static List<byte> ListDiff(List<byte> l1, List<byte> l2)
        {
            List<byte> toReturn = new List<byte>();
            foreach (byte elem in l1)
            {
                if (!l2.Contains(elem))
                {
                    toReturn.Add(elem);
                }
            }
            return toReturn;
        }



        // Conjunction between 2 constraints
        public void Conjunction(Constraint otherConstraint){

            //theConstraint += "{before Conjunction: '" + ClocksToString() + "' with '" + otherConstraint.ClocksToString() + "'}";
            //otherConstraint.theConstraint += "{before Conjunction: '" + ClocksToString() + "' with '" + otherConstraint.ClocksToString() + "'}";

            if (otherConstraint.theConstraint == "true" || otherConstraint.theConstraint == theConstraint)
            {
                return;
            }// just to keep display clean...
            if (theConstraint == "true") {
                theConstraint = otherConstraint.theConstraint;
                ClockList = otherConstraint.ClockList;
                return; 
            } // just to keep display clean...

            // Verifying the equality of the clock list
            if (!(ListIncluded(ClockList, otherConstraint.ClockList)
                && ListIncluded(otherConstraint.ClockList, ClockList)))
            {
                throw new InvalidOperationException("Constraints " + ToString() +
                    " and " + otherConstraint.ToString() + " have different clock lists: " + ClocksToString() +
                    " and " + otherConstraint.ClocksToString() + ".");
            }

            // ETIENNE SAYS: FAKE IMPLEMENTATION
            string operation = "and(" + otherConstraint.theConstraint + ", " + this.theConstraint + ")";
            string result = processConstraint(operation);

            theConstraint = result;
        }



        // Generate a new clock ID if not present yet
        public byte GetNewClockID()
        {
            // Case no clock: first clock index
            if (ClockList.Count() == 0)
            {
                // ETIENNE SAYS: DEBUG TEST
                //theConstraint = "[add new clock to empty list '" + ClocksToString() + "']" + theConstraint;

                // ETIENNE SAYS: DEBUG TEST
                return FIRST_CLOCK;
            }


            // ETIENNE SAYS: THIS MAY BE MORE EFFICIENT THAN THE SAME OPERATION IN DBM CLASS (n log n againt n*n)
            // Otherwise: look for the smallest unused clock index
            byte i = FIRST_CLOCK;
            // Copy the list
            List<byte> ClockListCopy = new List<byte>(ClockList);
            // Sort it
            ClockListCopy.Sort();
            // Look for the first index not present in the array
            while (i <= ClockList.Count())
            {
                if (ClockListCopy[i - 1] != i)
                {
                    // ETIENNE SAYS: DEBUG TEST
                    //theConstraint = "[add new unused clock to '" + ClocksToString() + "']" + theConstraint;

                    return i;
                }
                i++;
            }
            // ETIENNE SAYS: DEBUG TEST
            //theConstraint = "[add brand new clock to '" + ClocksToString() + "']" + theConstraint;

            
            // If no free clock index was found, return the next one
            return i; 
        }



        public bool IsSatisfiable()
        {
            // FAKE IMPLEMENTATION
            if (theConstraint == "false") { return false; } // keep the display clean
            if (theConstraint == "true") { return true; } // keep the display clean

            string operation = "satisfiable(" + theConstraint + ")";
            string result = processConstraint(operation);
            return polyopToBool(result);
        }


        public List<byte> GetNewClocks()
        {
            if (ClockList.Count() == 0)
            {
                return new List<byte>();
            }

            if (LatestClockIsNew)
            {
                List<byte> toReturn = new List<byte>(ClockList);
                toReturn.Remove(LatestClock);
                return toReturn;
            }

            return ClockList;
        }



        // Check if this is a subset of otherConstraint (or the converse ?!!)
        public bool IsSubSetOf(Constraint otherConstraint)
        {
            //Debug.Assert(IsCanonicalForm); /* chengbin */

            // ETIENNE SAYS: not convinced about those two optimizations
            // If other is true: yes
            if (otherConstraint.ClockList.Count() == 0)
            {
                return true;
            }

            // If this is true: no
            if (ClockList.Count() == 0)
            {
                return false;
            }

            // FAKE IMPLEMENTATION
            string operation = "included(" + this.theConstraint + ", " + otherConstraint.theConstraint + ")";
            string result = processConstraint(operation);
            return polyopToBool(result);
        }



        // Addition of a new clock set to 0 (if clockID already in, throws exception)
        public void AddClock(byte clockID)
        {


            // ETIENNE SAYS: DEBUG ONLY
            //theConstraint += "{will add clock " + clockID.ToString() + " to '" + ClocksToString() + "'}";


            // WHAT?!
            LatestClock = clockID;
            // WHAT?!
            if (ClockList.Count() == 0 || !ClockList.Contains(LatestClock))
            {
                LatestClockIsNew = true;
            }
#if Statistics
                if(ClockNumber < clockID)
                {
                    ClockNumber = clockID;
                }
#endif
            //// If the list of clocks is null, create it
            //if (ClockList == null)
            //{
            //    ClockList = new List<byte>(Constants.CONSTRAINT_NBCLOCK_INIT_SIZE);
            //}else{
                // If the clock already exists, do nothing
            if (ClockList.Contains(clockID))
            {
                throw new InvalidOperationException("Attempt to add clock " + clockID.ToString()
                    + " to the list of clocks '" + ClocksToString() + "'.");
            }
            //}

            // Add the clock
            ClockList.Add(clockID);

            // Add the constraint 'clock = 0'
            AddInequality(clockID, TimerOperationType.Equals, 0);
        }



        // Add an inequality of the form "clock ~ int"
        public void AddInequality(byte clockID, TimerOperationType op, int constant)
        {
            // ETIENNE SAYS: FAKE IMPLEMENTATION
            string inequality = ClockToString(clockID) + opToString(op) + constant.ToString();
            string operation = "and(" + this.theConstraint + ", " + inequality + ")";
            string result = processConstraint(operation);
            this.theConstraint = result;
        }



        // Add an inequality of the form "clock ~ parameter"
        public void AddParInequality(byte clockID, TimerOperationType op, string parameter)
        {
            // ETIENNE SAYS: FAKE IMPLEMENTATION

            // ETIENNE SAYS: WHAT'S THAT?
            //int clock = ClockList.IndexOf(clockID) + 1;

            // ETIENNE SAYS: just to keep display clean
            // if (theConstraint == "true") { theConstraint = ""; }
            // else { theConstraint += " AND "; }

            // ETIENNE SAYS: FAKE IMPLEMENTATION
            string inequality = ClockToString(clockID) + opToString(op) + parameter;
            string operation = "and(" + this.theConstraint + ", " + inequality + ")";
            string result = processConstraint(operation);
            this.theConstraint = result;
        }


        public static string ClockToString(byte clockID)
        {
            // ETIENNE SAYS: MAYBE USELESS WITH A POLYHEDRA LIBRARY
            return "x" + clockID.ToString();
        }

        public static string opToString(TimerOperationType op)
        {
            string result = "will be assigned later (function opToString)";
            switch (op)
            {
                case TimerOperationType.Equals:
                    result = "="; break;
                case TimerOperationType.GreaterThanOrEqualTo:
                    result = ">="; break;
                case TimerOperationType.LessThanOrEqualTo:
                    result = "<="; break;
                case TimerOperationType.GreaterThan:
                    result = ">"; break;
                case TimerOperationType.LessThan:
                    result = "<"; break;
            }
            return result;
        }


        // Conversion to string
        public override string ToString()
        {
            // ETIENNE SAYS: FAKE IMPLEMENTATION
            return theConstraint;
        }



        // Convert a list of clocks to a string
        private static string SomeClockstoString(List<byte> ClockList)
        {
            // Convert each clock to a string
            List<string> clocks_string = new List<string>(ClockList.Count());
            foreach (byte clockID in ClockList)
            {
                clocks_string.Add(ClockToString(clockID));
            }
            // Convert everything with a separator
            return string.Join(",", clocks_string.ToArray());
        }



        // Convert all clocks to string
        public string ClocksToString()
        {
            return SomeClockstoString(ClockList);
        }


        // Copy
        public Constraint Clone()
        {
            // ETIENNE SAYS: FAKE IMPLEMENTATION
            Constraint newConstraint = new Constraint();
            newConstraint.theConstraint = theConstraint;
            
            // Copy the list of clocks
            newConstraint.ClockList = new List<byte>(ClockList);

            return newConstraint;
        }


        // Return an unique identifier (?)
        // PROBLEM: canonical form not easy for constraints...
        public string GetID()
        {
            // FAKE IMPLEMENTATION
            return theConstraint;
        }

    }
}
