﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using PAT.Common;
using PAT.Common.Classes.LTS;
using PAT.Common.Classes.ModuleInterface;
using PAT.Common.GUI;
using PAT.Common.GUI.ModelChecker;
using PAT.Common.Ultility;
using PAT.PAR.GUI;
using PAT.PAR.LTS;
using PAT.PAR.Ultility;

namespace PAT.PAR
{
    public sealed class ModuleFacade : ModuleFacadeBase
    {

        public override string ModuleName
        {
            get
            {
                return "Parameterized Real-Time System Model";
            }
        }

        public ModuleFacade()
        {
        }

        protected override SpecificationBase InstanciateSpecification(string text, string options, string filePath)
        {
            return new Specification(text, options, filePath);
        }

        //protected override ModelCheckingForm InstanciateModelCheckingForm(string tabName)
        //{
        //    return new PARModelCheckingForm(tabName, Specification as Specification, true);
        //}

        public override string PrintLaTexString()
        {
            return PARUltility.GenerateLaTexString(Specification as Specification);
        }

        #region Example
        

        public override void ExampleMenualToolbarInitialize(ToolStripMenuItem ExampleMenu)
        {
            ToolStripMenuItem PARExamplesToolStripMenuItem =
                new ToolStripMenuItem("Parameterized Real-Time System Examples");
            PARExamplesToolStripMenuItem.Image = this.ModuleIcon;

            ExampleMenu.DropDownItems.AddRange(new ToolStripItem[]
                                                   {PARExamplesToolStripMenuItem});

            ToolStripMenuItem NonParameterizeToolStripMenuItem = new ToolStripMenuItem("Without Parameterization");
            ToolStripMenuItem ParameterizeToolStripMenuItem = new ToolStripMenuItem("With Parameterization");

            

            // 
            // PARExamplesToolStripMenuItem
            // 

            PARExamplesToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[]{
            NonParameterizeToolStripMenuItem,
            ParameterizeToolStripMenuItem});

            ToolStripMenuItem fischersProtocolToolStripMenuItem =
                new ToolStripMenuItem("Fischer's Mutual Exclusion Protocol");
            ToolStripMenuItem railwayCrosingToolStripMenuItem = new ToolStripMenuItem("Railway Crossing");
            ToolStripMenuItem bridgeCrossingToolStripMenuItem = new ToolStripMenuItem("Bridge Crossing Problem");
            ToolStripMenuItem railwayControlSystemToolStripMenuItem = new ToolStripMenuItem("Railway Control System");
            ToolStripMenuItem paceMakerToolStripMenuItem1 = new ToolStripMenuItem("Timed PaceMaker");
            ToolStripMenuItem lightControlSystemToolStripMenuItem = new ToolStripMenuItem("Light Control System");
            ToolStripMenuItem alternatingBitProtocolTimedToolStripMenuItem =
                new ToolStripMenuItem("Timed Alternating Bit Protocol ");
            ToolStripMenuItem cSMACDProtocolToolStripMenuItem = new ToolStripMenuItem("CSMA/CD Protocol");
            ToolStripMenuItem fiberDistributedDataInterfaceProtocolToolStripMenuItem =
                new ToolStripMenuItem("Fiber Distributed Data Interface Protocol");


            NonParameterizeToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            fischersProtocolToolStripMenuItem,
            railwayCrosingToolStripMenuItem,
            bridgeCrossingToolStripMenuItem,
            railwayControlSystemToolStripMenuItem,
            paceMakerToolStripMenuItem1,
            lightControlSystemToolStripMenuItem,
            alternatingBitProtocolTimedToolStripMenuItem,
            cSMACDProtocolToolStripMenuItem,
            fiberDistributedDataInterfaceProtocolToolStripMenuItem});

            ToolStripMenuItem ExRTSSToolStripMenuItem = new ToolStripMenuItem("ExRTSS");
            ToolStripMenuItem ParFischerToolStripMenuItem = new ToolStripMenuItem("Parameterzied Fischer");
            ToolStripMenuItem JobShopToolStripMenuItem = new ToolStripMenuItem("Job Shop Example");
            ToolStripMenuItem TrainAHV93ToolStripMenuItem = new ToolStripMenuItem("Train AHV93 Example");
            ToolStripMenuItem ParTrainCrossingToolStripMenuItem = new ToolStripMenuItem("Parameterized Train Crossing");

            ParameterizeToolStripMenuItem.DropDownItems.AddRange(new ToolStripItem[] {
            ExRTSSToolStripMenuItem,
            ParFischerToolStripMenuItem,
            JobShopToolStripMenuItem,
            TrainAHV93ToolStripMenuItem,
            ParTrainCrossingToolStripMenuItem
        });
            // 
            // fischersProtocolToolStripMenuItem
            // 
            fischersProtocolToolStripMenuItem.Name = "fischersProtocolToolStripMenuItem";
            fischersProtocolToolStripMenuItem.Click += new System.EventHandler(fischersProtocolToolStripMenuItem_Click);
            // 
            // railwayCrosingToolStripMenuItem
            // 
            railwayCrosingToolStripMenuItem.Name = "railwayCrosingToolStripMenuItem";
            railwayCrosingToolStripMenuItem.Click += new System.EventHandler(railwayCrosingToolStripMenuItem_Click);
            // 
            // bridgeCrossingToolStripMenuItem
            // 
            bridgeCrossingToolStripMenuItem.Name = "bridgeCrossingToolStripMenuItem";
            bridgeCrossingToolStripMenuItem.Click += new System.EventHandler(bridgeCrossingToolStripMenuItem_Click);
            // 
            // railwayControlSystemToolStripMenuItem
            // 
            railwayControlSystemToolStripMenuItem.Name = "railwayControlSystemToolStripMenuItem";
            railwayControlSystemToolStripMenuItem.Click += new System.EventHandler(railwayControlSystemToolStripMenuItem_Click);
            // 
            // paceMakerToolStripMenuItem1
            // 
            paceMakerToolStripMenuItem1.Name = "paceMakerToolStripMenuItem1";
            paceMakerToolStripMenuItem1.Click += new System.EventHandler(paceMakerToolStripMenuItem1_Click);
            // 
            // lightControlSystemToolStripMenuItem
            // 
            lightControlSystemToolStripMenuItem.Name = "lightControlSystemToolStripMenuItem";
            lightControlSystemToolStripMenuItem.Click += new System.EventHandler(lightControlSystemToolStripMenuItem_Click);
            // 
            // alternatingBitProtocolTimedToolStripMenuItem
            // 
            alternatingBitProtocolTimedToolStripMenuItem.Name = "alternatingBitProtocolTimedToolStripMenuItem";
            alternatingBitProtocolTimedToolStripMenuItem.Click += new System.EventHandler(alternatingBitProtocolTimedToolStripMenuItem_Click);
            // 
            // cSMACDProtocolToolStripMenuItem
            // 
            cSMACDProtocolToolStripMenuItem.Name = "cSMACDProtocolToolStripMenuItem";
            cSMACDProtocolToolStripMenuItem.Click += new System.EventHandler(cSMACDProtocolToolStripMenuItem_Click);
            // 
            // fiberDistributedDataInterfaceProtocolToolStripMenuItem
            // 
            fiberDistributedDataInterfaceProtocolToolStripMenuItem.Name = "fiberDistributedDataInterfaceProtocolToolStripMenuItem";
            fiberDistributedDataInterfaceProtocolToolStripMenuItem.Click += new System.EventHandler(fiberDistributedDataInterfaceProtocolToolStripMenuItem_Click);
            //
            //ExRTSSToolStripMenuItem
            //
            ExRTSSToolStripMenuItem.Name = "ExRTSSToolStripMenuItem";
            ExRTSSToolStripMenuItem.Click += new System.EventHandler(ExRTSSToolStripMenuItem_Click);
            //
            //ParFischerToolStripMenuItem 
            //
            ParFischerToolStripMenuItem.Name = "ParFischerToolStripMenuItem";
            ParFischerToolStripMenuItem.Click += new System.EventHandler(ParFischerToolStripMenuItem_Click);
            //
            //JobShopToolStripMenuItem
            //
            JobShopToolStripMenuItem.Name = "JobShopToolStripMenuItem";
            JobShopToolStripMenuItem.Click += new System.EventHandler(JobShopToolStripMenuItem_Click);
            //
            //TrainAHV93ToolStripMenuItem
            //
            TrainAHV93ToolStripMenuItem.Name = "TrainAHV93ToolStripMenuItem.Name";
            TrainAHV93ToolStripMenuItem.Click += new System.EventHandler(TrainAHV93ToolStripMenuItem_Click);
            //
            //ParTrainCrossingToolStripMenuItem
            //
            ParTrainCrossingToolStripMenuItem.Name = "ParTrainCrossingToolStripMenuItem";
            ParTrainCrossingToolStripMenuItem.Click += new System.EventHandler(ParTrainCrossingToolStripMenuItem_Click);
        }

        private void ExRTSSToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.ExRTSS);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadExRTSS(), ModuleName);
            }
        }

        private void ParFischerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.ParFischerProtocol);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadParFischer(form.ThirdNumber, form.Number, form.SizeNumber), ModuleName);
            }
        }

        private void JobShopToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.JobShop);
            if(form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadJobShop(), ModuleName);
            }
        }

        private void TrainAHV93ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.TrainAHV93);
            if(form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadTrainAHV93(), ModuleName);
            }
        }

        private void ParTrainCrossingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.ParTrainCrossing);
            if(form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadParTrainRTS(), ModuleName);
            }
        }

        private void fischersProtocolToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.FischerProtocol);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadFischerProtocol(form.Number), ModuleName);
            }
        }

        private void railwayCrosingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.RailwayCrossing);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadRailwayCrosing(), ModuleName);
            }
        }


        private void bridgeCrossingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.BridgeCrossingProblem);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadBridgeCrossingProblem(form.Number), ModuleName);
            }
        }



        private void railwayControlSystemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.RailwayControl);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadTrainWayControl(form.Number), ModuleName);
            }
        }

        private void paceMakerToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.PaceMakerTimed);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadTimedPaceMaker(), ModuleName);
            }
        }



        private void lightControlSystemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.LightControlSystem);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadLightControlSystem(), ModuleName);
            }
        }

        private void alternatingBitProtocolTimedToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.ABPTimed);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadABPTimedSystem(form.Number), ModuleName);
            }
        }

        private void cSMACDProtocolToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.CSMACD_RTS);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadCSMACD_RTS(form.Number), ModuleName);
            }
        }

        private void fiberDistributedDataInterfaceProtocolToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExampleForm form = new ExampleForm(PATExample.FDDI);
            if (form.ShowDialog() == DialogResult.OK)
            {
                ShowModel(Examples.LoadFDDI(form.Number), ModuleName);
            }
        }

        #endregion


        #region Templates

        public override List<string> GetTemplateTypes()
        {
            List<string> modelTypes = new List<string>();
            modelTypes.Add("Assertions");
            modelTypes.Add("Others");
            return modelTypes;
        }

        public override SortedList<string, string> GetTemplateNames(string type)
        {
            SortedList<string, string> templates = new SortedList<string, string>();

            if (type == "Assertions")
            {
                templates.Add("Deadlock Checking", "Deadlock Checking");
                templates.Add("LTL Checking", "Linear Temparal Logic (LTL) Checking");
                templates.Add("Reachability Checking", "Reachability Checking");
                templates.Add("Refinement Checking", "Refinement Checking");
            }

            return templates;
        }

        public override string GetTemplateModel(string templateName)
        {
            StringBuilder sb = new StringBuilder();

            if (templateName == "Deadlock Checking")
            {
                sb.AppendLine("P(i) = (a -> Skip) timeout[5](b -> P(i));");
                sb.AppendLine("Q() = b -> Wait[10]; Q();");

                sb.AppendLine("System() = P(0) ||| Q();");
                sb.AppendLine("#assert System() deadlockfree;");

            }
            else if (templateName == "LTL Checking")
            {
                sb.AppendLine("P(i) = (a -> Skip) timeout[5](b -> P(i));");
                sb.AppendLine("Q() = b -> Wait[10]; Q();");

                sb.AppendLine("System() = P(0) ||| Q();");
                sb.AppendLine("#assert System() |= []<>b;");
            }
            else if (templateName == "Reachability Checking")
            {
                sb.AppendLine("var x = 0;");

                sb.AppendLine("P(i) = a -> Skip;");
                sb.AppendLine("Q(i) = b.i{x=i;} -> Q(i+1);");

                sb.AppendLine("System() = P(0) ||| Q(0);");

                sb.AppendLine("#define goal x == 10;");
                sb.AppendLine("#assert System() reaches goal;");
            }
            else if (templateName == "Refinement Checking")
            {
                sb.AppendLine("////////////////The Model//////////////////");
                sb.AppendLine("#define N 2;");

                sb.AppendLine("Phil(i) = get.i.(i+1)%N -> get.i.i -> eat.i -> put.i.(i+1)%N -> put.i.i -> Phil(i);");
                sb.AppendLine("Fork(x) = get.x.x -> put.x.x -> Fork(x) [] get.(x-1)%N.x -> put.(x-1)%N.x -> Fork(x);");
                sb.AppendLine("College() = ||x:{0..N-1}@(Phil(x)||Fork(x));");
                sb.AppendLine("Implementation() = College() \\ {get.0.0,get.0.1,put.0.0,put.0.1,eat.1,get.1.1,get.1.0,put.1.1,put.1.0};");

                sb.AppendLine("Specification() = eat.0 -> Specification();");

                sb.AppendLine("////////////////The Properties//////////////////");
                sb.AppendLine("#assert Implementation() refines Specification();");
                sb.AppendLine("#assert Specification() refines Implementation();");
                sb.AppendLine("#assert Implementation() refines <F> Specification();");
                sb.AppendLine("#assert Specification() refines <F> Implementation();");
                sb.AppendLine("#assert Implementation() refines <FD> Specification();");
                sb.AppendLine("#assert Specification() refines <FD> Implementation();");
            }
            return sb.ToString();
        }

        #endregion

        //configuration related interface
        public override void ReadConfiguration()
        {
            ////link RTS
            PARUltility.LINK_PAR = ConfigSettings.Settings.GetOption(ModuleName, "LINK_PAR", PARUltility.LINK_PAR.ToString()) == "True";

            ////Tau Urgent
            PARUltility.TAU_URGENT = ConfigSettings.Settings.GetOption(ModuleName, "TAU_URGENT", PARUltility.TAU_URGENT.ToString()) == "True";

            ////Timed Refinement clock ceiling
            PARUltility.TIME_REFINEMENT_CLOCK_CEILING = ConfigSettings.Settings.GetOption(ModuleName, "TIME_REFINEMENT_CLOCK_CEILING", PARUltility.TIME_REFINEMENT_CLOCK_CEILING);

            ////Timed Refinement clock floor
            PARUltility.TIME_REFINEMENT_CLOCK_FLOOR = ConfigSettings.Settings.GetOption(ModuleName, "TIME_REFINEMENT_CLOCK_FLOOR", PARUltility.TIME_REFINEMENT_CLOCK_FLOOR);

        }

        public override void WriteConfiguration()
        {
            ////link RTS
            ConfigSettings.Settings.SetOption(ModuleName, "LINK_PAR", PARUltility.LINK_PAR.ToString());

            ////Tau Urgent
            ConfigSettings.Settings.SetOption(ModuleName, "TAU_URGENT", PARUltility.TAU_URGENT.ToString());

            ////Timed Refinement clock ceiling
            ConfigSettings.Settings.SetOption(ModuleName, "TIME_REFINEMENT_CLOCK_CEILING", PARUltility.TIME_REFINEMENT_CLOCK_CEILING.ToString());

            ////Timed Refinement clock floor
            ConfigSettings.Settings.SetOption(ModuleName, "TIME_REFINEMENT_CLOCK_FLOOR", PARUltility.TIME_REFINEMENT_CLOCK_FLOOR.ToString());
        }

        public override OptionPanelInterface GetOptionPanel()
        {
            return new OptionPanel();
        }
    }
}